#include <math.h>
#include <stdlib.h>
#include <stdio.h>

#define BIN 140
#define MAX 2000
#define INFINIT    1.0e10
#define RESTENE    8.1871e-7             /*  in erg   */ 
#define LIGHT      2.9979e10             /*  in cm/s  */
#define PI         3.141592653589793          

main()
{
  double norm;
  double g_max, g_min;
  double index,ratio;
  double comp1;
  double temp,spec; 
  double expcut;
  double ind_tp1, ind_tp2;
  double ened_tot, ened_kin, num_tot;
  double gm[MAX],N_gm[MAX]; 
  double k_gm[MAX],r_gm[MAX];       
  int i, column;  
  FILE   *fp0; 
  char   file0[64]; 

  printf("Input parameters for Electron Distribution\n");

  printf("Normalization : Q_0 (electrons/cm^3/ene) = ?  ");
  scanf("%lf",&norm);
  printf("Gamma_min  = ?  ");
  scanf("%lf",&g_min);
  printf("Gamma_Max = ?  ");
  scanf("%lf",&g_max);
  printf("Index = ?  ");
  scanf("%lf",&spec);
  printf("Output  Filename?"); 
  scanf("%s",file0);

  if(NULL == (fp0 = fopen(file0,"w"))){
     printf("\n Cannot Open File : %s \n\n", file0);
     exit(1); 
   }

  column = BIN;

  for(i=1; i<=BIN; i++){
     ratio     = (double)(INFINIT/g_min);
     index     = (double)i/BIN;
     gm[i]     = (double)g_min * pow(ratio,index);

     expcut    = (double)gm[i]/g_max;    
     comp1     = (double)1.0/exp(expcut);
     temp      = (double)gm[i];
     N_gm[i]   = (double)norm*pow(temp,spec)*comp1;
     r_gm[i]   = (double)gm[i]*N_gm[i]*RESTENE; 
     k_gm[i]   = (double)(gm[i]-1.0)*N_gm[i]*RESTENE;  

     fprintf(fp0, "%20.15e %20.15e\n", gm[i], N_gm[i]);
   }
 
   ind_tp1  = spec + 2.0;
   ind_tp2  = spec + 1.0;

   if(spec == -2.0){
      ened_tot = norm * RESTENE * (log(g_max) - log(g_min));
      ened_kin = ened_tot - 
                 norm * RESTENE * (pow(g_max, ind_tp2) - pow(g_min, ind_tp2))
                 /ind_tp2;              
   }else{ 
      ened_tot = norm * RESTENE * (pow(g_max, ind_tp1) - pow(g_min, ind_tp1))
                 /ind_tp1;
      ened_kin = ened_tot - 
                 norm * RESTENE * (pow(g_max, ind_tp2) - pow(g_min, ind_tp2))
                 /ind_tp2;              
   } 

     printf("Total Electron Power in the source frame is\n");
     printf("Energy Density (total) = %e (erg/cm^3)\n ", ened_tot);
     printf("Energy Density (kinetic) = %e (erg/cm^3)\n ", ened_kin);
}


